Index: trunk/src/kmk/config.h.darwin
===================================================================
--- trunk/src/kmk/config.h.darwin	(revision 3248)
+++ trunk/src/kmk/config.h.darwin	(revision 3249)
@@ -1,4 +1,4 @@
 /* config.h.  Generated from config.h.in by configure.  */
-/* config.h.in.  Generated from configure.in by autoheader.  */
+/* config.h.in.  Generated from configure.ac by autoheader.  */
 
 /* Define to 1 if the `closedir' function returns void instead of `int'. */
@@ -20,5 +20,5 @@
 
 /* Use high resolution file timestamps if nonzero. */
-#define FILE_TIMESTAMP_HI_RES 0
+#define FILE_TIMESTAMP_HI_RES 1
 
 /* Define to 1 if the `getloadavg' function needs to be run setuid or setgid.
@@ -33,19 +33,28 @@
 #define HAVE_ALLOCA_H 1
 
-/* Define to 1 if your compiler conforms to the ANSI C standard. */
-#define HAVE_ANSI_COMPILER 1
-
 /* Define to 1 if you have the `atexit' function. */
 #define HAVE_ATEXIT 1
 
-/* Define to 1 if you have the `bsd_signal' function. */
-#define HAVE_BSD_SIGNAL 1
-#define HAVE_DECL_BSD_SIGNAL 1
-
 /* Use case insensitive file names */
 /* #undef HAVE_CASE_INSENSITIVE_FS */
 
 /* Define to 1 if you have the clock_gettime function. */
-/* #undef HAVE_CLOCK_GETTIME */
+#define HAVE_CLOCK_GETTIME 1
+
+/* Define to 1 if you have the declaration of `bsd_signal', and to 0 if you
+   don't. */
+#define HAVE_DECL_BSD_SIGNAL 1
+
+/* Define to 1 if you have the declaration of `dlerror', and to 0 if you
+   don't. */
+#define HAVE_DECL_DLERROR 1
+
+/* Define to 1 if you have the declaration of `dlopen', and to 0 if you don't.
+   */
+#define HAVE_DECL_DLOPEN 1
+
+/* Define to 1 if you have the declaration of `dlsym', and to 0 if you don't.
+   */
+#define HAVE_DECL_DLSYM 1
 
 /* Define to 1 if you have the declaration of `sys_siglist', and to 0 if you
@@ -65,10 +74,10 @@
 #define HAVE_DIRENT_H 1
 
-/* Define to 1 if you don't have `vprintf' but do have `_doprnt.' */
-/* #undef HAVE_DOPRNT */
-
 /* Use platform specific coding */
 /* #undef HAVE_DOS_PATHS */
 
+/* Define to 1 if you have the `dup' function. */
+#define HAVE_DUP 1
+
 /* Define to 1 if you have the `dup2' function. */
 #define HAVE_DUP2 1
@@ -107,7 +116,13 @@
 #define HAVE_GETTIMEOFDAY 1
 
+/* Embed GNU Guile support */
+/* #undef HAVE_GUILE */
+
 /* Define to 1 if you have the <inttypes.h> header file. */
 #define HAVE_INTTYPES_H 1
 
+/* Define to 1 if you have the `isatty' function. */
+#define HAVE_ISATTY 1
+
 /* Define to 1 if you have the `dgc' library (-ldgc). */
 /* #undef HAVE_LIBDGC */
@@ -146,4 +161,7 @@
 #define HAVE_PIPE 1
 
+/* Define to 1 if you have the `pselect' function. */
+#define HAVE_PSELECT 1
+
 /* Define to 1 if you have the `pstat_getdynamic' function. */
 /* #undef HAVE_PSTAT_GETDYNAMIC */
@@ -191,7 +209,4 @@
 /* #undef HAVE_SOCKET */
 
-/* Define to 1 if you have the <stdarg.h> header file. */
-#define HAVE_STDARG_H 1
-
 /* Define to 1 if you have the <stdint.h> header file. */
 #define HAVE_STDINT_H 1
@@ -206,4 +221,23 @@
 /* #undef HAVE_STRCMPI */
 
+/* Define to 1 if you have the `strcoll' function and it is properly defined.
+   */
+#define HAVE_STRCOLL 1
+
+/* Define to 1 if you have the `strdup' function. */
+#define HAVE_STRDUP 1
+
+/* Define to 1 if you have the `strerror' function. */
+#define HAVE_STRERROR 1
+
+/* Define to 1 if you have the `stricmp' function. */
+/* #undef HAVE_STRICMP */
+
+/* Define to 1 if you have the <strings.h> header file. */
+#define HAVE_STRINGS_H 1
+
+/* Define to 1 if you have the <string.h> header file. */
+#define HAVE_STRING_H 1
+
 /* Define to 1 if you have the `strncasecmp' function. */
 #define HAVE_STRNCASECMP 1
@@ -212,33 +246,14 @@
 /* #undef HAVE_STRNCMPI */
 
-/* Define to 1 if you have the `strncmp' function. */
+/* Define to 1 if you have the `strndup' function. */
+#define HAVE_STRNDUP 1
+
+/* Define to 1 if you have the `strnicmp' function. */
 /* #undef HAVE_STRNICMP */
-
-/* Define to 1 if you have the `strcoll' function and it is properly defined.
-   */
-#define HAVE_STRCOLL 1
-
-/* Define to 1 if you have the `strdup' function. */
-#define HAVE_STRDUP 1
-
-/* Define to 1 if you have the `strndup' function. */
-/* #undef HAVE_STRNDUP  */
-
-/* Define to 1 if you have the `strerror' function. */
-#define HAVE_STRERROR 1
-
-/* Define to 1 if you have the `stricmp' function. */
-/* #undef HAVE_STRICMP */
-
-/* Define to 1 if you have the <strings.h> header file. */
-#define HAVE_STRINGS_H 1
-
-/* Define to 1 if you have the <string.h> header file. */
-#define HAVE_STRING_H 1
 
 /* Define to 1 if you have the `strsignal' function. */
 #define HAVE_STRSIGNAL 1
 
-/* Define to 1 if `n_un.n_name' is member of `struct nlist'. */
+/* Define to 1 if `n_un.n_name' is a member of `struct nlist'. */
 /* #undef HAVE_STRUCT_NLIST_N_UN_N_NAME */
 
@@ -257,4 +272,7 @@
 #define HAVE_SYS_RESOURCE_H 1
 
+/* Define to 1 if you have the <sys/select.h> header file. */
+#define HAVE_SYS_SELECT_H 1
+
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #define HAVE_SYS_STAT_H 1
@@ -272,5 +290,11 @@
 #define HAVE_SYS_WAIT_H 1
 
-/* Define to 1 if you have the \`union wait' type in <sys/wait.h>. */
+/* Define to 1 if you have the `ttyname' function. */
+#define HAVE_TTYNAME 1
+
+/* Define to 1 if the system has the type `uintmax_t'. */
+#define HAVE_UINTMAX_T 1
+
+/* Define to 1 if you have the 'union wait' type in <sys/wait.h>. */
 /* #undef HAVE_UNION_WAIT */
 
@@ -278,6 +302,6 @@
 #define HAVE_UNISTD_H 1
 
-/* Define to 1 if you have the <varargs.h> header file. */
-/* #undef HAVE_VARARGS_H */
+/* Define to 1 if the system has the type `unsigned long long int'. */
+#define HAVE_UNSIGNED_LONG_LONG_INT 1
 
 /* Define to 1 if you have the `vfork' function. */
@@ -287,7 +311,4 @@
 /* #undef HAVE_VFORK_H */
 
-/* Define to 1 if you have the `vprintf' function. */
-#define HAVE_VPRINTF 1
-
 /* Define to 1 if you have the `wait3' function. */
 #define HAVE_WAIT3 1
@@ -302,9 +323,12 @@
 #define HAVE_WORKING_VFORK 1
 
-/* Build host information. (not used by kmk) */
-#define MAKE_HOST "i386-apple-darwin9.4.0"
+/* Build host information. */
+#define MAKE_HOST "x86_64-apple-darwin16.7.0"
 
 /* Define to 1 to enable job server support in GNU make. */
 #define MAKE_JOBSERVER 1
+
+/* Define to 1 to enable 'load' support in GNU make. */
+/* #undef MAKE_LOAD */
 
 /* Define to 1 to enable symbolic link timestamp checking. */
@@ -318,7 +342,4 @@
 /* #undef NLIST_STRUCT */
 
-/* Define to 1 if your C compiler doesn't accept -c and -o together. */
-/* #undef NO_MINUS_C_MINUS_O */
-
 /* Name of package */
 #define PACKAGE "make"
@@ -331,18 +352,18 @@
 
 /* Define to the full name and version of this package. */
-#define PACKAGE_STRING "GNU make 3.82"
+#define PACKAGE_STRING "GNU make 4.2.1"
 
 /* Define to the one symbol short name of this package. */
 #define PACKAGE_TARNAME "make"
 
+/* Define to the home page for this package. */
+#define PACKAGE_URL "http://www.gnu.org/software/make/"
+
 /* Define to the version of this package. */
-#define PACKAGE_VERSION "3.82"
+#define PACKAGE_VERSION "4.2.1"
 
 /* Define to the character that separates directories in PATH. */
 #define PATH_SEPARATOR_CHAR ':'
 
-/* Define to 1 if the C compiler supports function prototypes. */
-#define PROTOTYPES 1
-
 /* Define as the return type of signal handlers (`int' or `void'). */
 #define RETSIGTYPE void
@@ -353,9 +374,4 @@
 /* Define to 1 if the SCCS 'get' command understands the '-G<file>' option. */
 /* #undef SCCS_GET_MINUS_G */
-
-/* Define to 1 if the `setvbuf' function takes the buffering type as its
-   second argument and the buffer pointer as the third, as on System V before
-   release 3. */
-/* #undef SETVBUF_REVERSED */
 
 /* If using the C implementation of alloca, define if you know the
@@ -374,5 +390,8 @@
 
 /* Define if struct stat contains a nanoseconds field */
-/* #undef ST_MTIM_NSEC */
+#define ST_ATIM_NSEC st_atimespec.tv_nsec
+
+/* Define if struct stat contains a nanoseconds field */
+#define ST_MTIM_NSEC st_mtimespec.tv_nsec
 
 /* Define to 1 on System V Release 4. */
@@ -389,6 +408,28 @@
 /* #undef UMAX4_3 */
 
+/* Enable extensions on AIX 3, Interix.  */
+#ifndef _ALL_SOURCE
+# define _ALL_SOURCE 1
+#endif
+/* Enable GNU extensions on systems that have them.  */
+#ifndef _GNU_SOURCE
+# define _GNU_SOURCE 1
+#endif
+/* Enable threading extensions on Solaris.  */
+#ifndef _POSIX_PTHREAD_SEMANTICS
+# define _POSIX_PTHREAD_SEMANTICS 1
+#endif
+/* Enable extensions on HP NonStop.  */
+#ifndef _TANDEM_SOURCE
+# define _TANDEM_SOURCE 1
+#endif
+/* Enable general extensions on Solaris.  */
+#ifndef __EXTENSIONS__
+# define __EXTENSIONS__ 1
+#endif
+
+
 /* Version number of package */
-#define VERSION "3.82"
+#define VERSION "4.2.1"
 
 /* Use platform specific coding */
@@ -398,9 +439,7 @@
 /* #undef WITH_DMALLOC */
 
-/* Define to 1 if on AIX 3.
-   System headers sometimes define this.
-   We just want to avoid a redefinition error message.  */
-#ifndef _ALL_SOURCE
-/* # undef _ALL_SOURCE */
+/* Enable large inode numbers on Mac OS X 10.5.  */
+#ifndef _DARWIN_USE_64_BIT_INODE
+# define _DARWIN_USE_64_BIT_INODE 1
 #endif
 
@@ -421,7 +460,4 @@
 /* #undef _POSIX_SOURCE */
 
-/* Define like PROTOTYPES; this can be used by system headers. */
-#define __PROTOTYPES 1
-
 /* Define to empty if `const' does not conform to ANSI C. */
 /* #undef const */
@@ -430,11 +466,21 @@
 /* #undef gid_t */
 
+/* Define to `long int' if <sys/types.h> does not define. */
+/* #undef off_t */
+
 /* Define to `int' if <sys/types.h> does not define. */
 /* #undef pid_t */
 
+/* Define to `unsigned int' if <sys/types.h> does not define. */
+/* #undef size_t */
+
+/* Define to `int' if <sys/types.h> does not define. */
+/* #undef ssize_t */
+
 /* Define to `int' if <sys/types.h> doesn't define. */
 /* #undef uid_t */
 
-/* Define uintmax_t if not defined in <stdint.h> or <inttypes.h>. */
+/* Define to the widest unsigned integer type if <stdint.h> and <inttypes.h>
+   do not define. */
 /* #undef uintmax_t */
 