Index: trunk/src/shlwapi/shlwapi.def
===================================================================
--- trunk/src/shlwapi/shlwapi.def	(revision 3251)
+++ trunk/src/shlwapi/shlwapi.def	(revision 3253)
@@ -1,3 +1,3 @@
-; $Id: shlwapi.def,v 1.7 2000-01-31 22:50:51 phaller Exp $
+; $Id: shlwapi.def,v 1.8 2000-03-27 21:46:20 sandervl Exp $
 
 LIBRARY SHLWAPI INITINSTANCE TERMINSTANCE
@@ -177,6 +177,6 @@
     ; 168    stub    IntlStrEqWorkerW
 
-;    PathAddBackslashA 				= SHELL32.PathAddBackslashA
-;    PathAddBackslashW 				= SHELL32.PathAddBackslashW
+;    PathAddBackslashA                          = SHELL32.PathAddBackslashA
+;    PathAddBackslashW                          = SHELL32.PathAddBackslashW
 
     ; 171    stub    PathAddExtensionA
@@ -202,6 +202,6 @@
     ; 191    stdcall PathFindExtensionA (ptr) PathFindExtensionA
     ; 192    stdcall PathFindExtensionW (ptr) PathFindExtensionW
-;    PathFindFileNameA            		= SHELL32.PathFindFilenameA
-;    PathFindFileNameW            		= SHELL32.PathFindFilenameW
+;    PathFindFileNameA                          = SHELL32.PathFindFilenameA
+;    PathFindFileNameW                          = SHELL32.PathFindFilenameW
     ; 195    stub    PathFindNextComponentA
     ; 196    stub    PathFindNextComponentW
@@ -225,6 +225,6 @@
     ; 214    stdcall PathIsRelativeW (ptr) PathIsRelativeW
 
-;    PathIsRootA				= SHELL32.PathIsRootA
-;    PathIsRootW				= SHELL32.PathIsRootW
+;    PathIsRootA                                = SHELL32.PathIsRootA
+;    PathIsRootW                                = SHELL32.PathIsRootW
 
     ; 217    stub    PathIsSameRootA
@@ -245,6 +245,6 @@
     ; 232    stub    PathMakeSystemFolderW
 
-;    PathMatchSpecA		       = SHELL32.PathMatchSpecA
-;    PathMatchSpecW		       = SHELL32.PathMatchSpecW
+;    PathMatchSpecA                    = SHELL32.PathMatchSpecA
+;    PathMatchSpecW                    = SHELL32.PathMatchSpecW
 
     ; 235    stub    PathParseIconLocationA
@@ -265,5 +265,5 @@
     ; 248    stub    PathRemoveExtensionW
 
-;    PathRemoveFileSpecA			= SHELL32.PathRemoveFileSpec
+;    PathRemoveFileSpecA                        = SHELL32.PathRemoveFileSpec
 
     ; 250    stub    PathRemoveFileSpecW
@@ -417,6 +417,6 @@
 
 EXPORTS
-    PathAddBackslashA = _PathAddBackslashA@4			@169
-    PathAddBackslashW = _PathAddBackslashW@4			@170
+    PathAddBackslashA = _PathAddBackslashA@4                    @169
+    PathAddBackslashW = _PathAddBackslashW@4                    @170
 
     PathAppendA       = _PathAppendA@8                          @173
@@ -431,6 +431,6 @@
     PathFileExistsW   = _PathFileExistsW@4                       @190
 
-    PathFindFileNameA = _PathFindFilenameA@4			@193
-    PathFindFileNameW = _PathFindFilenameW@4			@194
+    PathFindFileNameA = _PathFindFilenameA@4                    @193
+    PathFindFileNameW = _PathFindFilenameW@4                    @194
 
     PathFindOnPathA   = _PathFindOnPathA@8                      @197
@@ -443,20 +443,20 @@
     PathIsRelativeA   = _PathIsRelativeA@4                      @213
     PathIsRelativeW   = _PathIsRelativeW@4                      @214
-    PathIsRootA	      = _PathIsRootA@4				@215
-    PathIsRootW	      = _PathIsRootW@4				@216
+    PathIsRootA       = _PathIsRootA@4                          @215
+    PathIsRootW       = _PathIsRootW@4                          @216
 
     PathIsUNCA        = _PathIsUNCA@4                           @221
     PathIsUNCW        = _PathIsUNCW@4                           @226
 
-    PathMatchSpecA    = _PathMatchSpecA@8			@233
-    PathMatchSpecW    = _PathMatchSpecA@8			@234
+    PathMatchSpecA    = _PathMatchSpecA@8                       @233
+    PathMatchSpecW    = _PathMatchSpecW@8                       @234
     PathQuoteSpacesA  = _PathQuoteSpacesA@4                     @237
     PathQuoteSpacesW  = _PathQuoteSpacesW@4                     @238
 
-    PathRemoveBackslashA = _PathRemoveBackslashA@4             	@243
-    PathRemoveBackslashW = _PathRemoveBackslashA@4             	@244
+    PathRemoveBackslashA = _PathRemoveBackslashA@4              @243
+    PathRemoveBackslashW = _PathRemoveBackslashW@4              @244
     PathRemoveBlanksA    = _PathRemoveBlanksA@4                 @245
     PathRemoveBlanksW    = _PathRemoveBlanksW@4                 @246
-    PathRemoveFileSpecA  = _PathRemoveFileSpecA@4		@249
+    PathRemoveFileSpecA  = _PathRemoveFileSpecA@4               @249
 
     PathSetDlgItemPathA  = _PathSetDlgItemPathA@12              @255
@@ -494,2 +494,3 @@
     StrRetToBufW         = _StrRetToBufW@16                     @401
 
+